#include <stdlib.h>

/* T = taula [0..4] de real */
typedef float T[5];

/*
 * Constructor de tipus apuntador
 * IntPointer s un tipus apuntador a enter
 */
typedef int *IntPointer;

int main(void)
{
  /* t1 s de tipus T */
  T t1;

  t1[0] = 1;
  t1[1] = 2;
  t1[2] = 3;
  t1[3] = 4;
  t1[4] = 5;

  /*
   * t2 s una taula [0..4] de enter
   * el tipus s annim
   */
  float t2[5];

  t2[0] = 1;
  t2[1] = 2;
  t2[2] = 3;
  t2[3] = 4;
  t2[4] = 5;

  /*  */
  int a;
  a = 3;

  /* c s de tipus IntPointer */
  IntPointer c;

  /*
   * b s un apuntador a enter
   * el tipus s annim
   */
  int *b;
  
  /*
   * Operadors bsics: adrea &
   * &a l'adrea de la variable a
   * b apunta a a
   */
  b = &a;
  c = &a;

  /*
   * Operadors bsics: desreferncia *
   * *b el valor de l'objecte apuntat per b
   */
  a = *b + 10;


  /*
   * Operadors bsics: desreferncia *
   * *b el valor de l'objecte apuntat per b
   */
  *b = 5;

  /* a i *b sn sinnims */


  /* p i q sn apuntadors a real */
  float *p, *q;

  /* *p o t1[2] sn sinnims */
  p = &t1[2];
  *p = *p + 10;
  t1[2] = 3;

  /*
   * Aritmtica d'apuntadors: 
   * suma d'un enter a un apuntador
   * q apunta al segent real desprs de p
   * *q i t1[3] sn sinnims
   */
  q = p + 1;
  *q = *q + 10;
  t1[3] = 4;

  /*
   * q apunta dos reals desprs de p
   * *q i t1[4] sn sinnims
   */
  q = p + 2;
  *q = *q + 10;
  t1[4] = 5;

  /*
   * Relaci entre apuntadors i taules
   * *p, *q i t1[0] sn sinnims
   */
  p = &t1[0];
  q = t1;
  *p = 100;
  *q = 200;
  t1[0] = 1;

  float x;


  /*
   * Apuntadors
   *     +
   * Aritmtica d'apuntadors
   *     =
   * Taules
   */
  x = t1[1];
  x = 0;
  x = *(p + 1);
  x = 0;
  x = *(q + 1);
  x = 0;
  x = p[1];
  x = 0;
  x = q[1];
  x = 0;
  x = *(t1 + 1);

  x = t1[2];
  x = 0;
  x = *(p + 2);
  x = 0;
  x = *(q + 2);
  x = 0;
  x = p[2];
  x = 0;
  x = q[2];
  x = 0;
  x = *(t1 + 2);

  x = t1[0];
  x = 0;
  x = *(p + 0);
  x = 0;
  x = *(q + 0);
  x = 0;
  x = p[0];
  x = 0;
  x = q[0];
  x = 0;
  x = *(t1 + 0);

  /*
   * Per qu NO es poden assignar taules en C?
   */
  p = t1;
  q = t2;
  p = q;

  /*
   * t1 = t2;
   *
   * main-1.c:161: error: incompatible types in assignment
   */

  return EXIT_SUCCESS;
}
