#include <assert.h>
#include <stdlib.h>

int main(void)
{
  int a, *p;
  float b, *q;

  a = 3;
  b = 5.7;
  p = &a;
  /*
   * C s un llenguatge fortament tipificat
   *
   * q = p;
   *
   * main-2.c:11: warning: assignment from incompatible pointer type
   */

  /* Apuntador a qualsevol tipus */
  void *r;

  /* Es relaxa la tipificaci forta quan hi ha void* */
  r = p;
  q = r;

  /*
   * Memria dinmica: reserva
   *
   * void *malloc (size_t size);
   */
  p = malloc(sizeof(float));
  assert(p != NULL);

  /*
   * Memria dinmica: s
   */
  *p = 3.7;

  /*
   * Memria dinmica: alliberament
   *
   * void free (void *ptr);
   */
  free(p);

  /*
   * Apuntador + Aritmtica = Taula
   *
   * Com reservar taules en temps d'execuci?
   */
  a = 5;
  p = malloc(sizeof(int) * a);
  assert(p != NULL);

  int i;

  i = 0;
  while (!(i >= a)) {
    p[i] = i * 10 + 1;
    i = i + 1;
  }

  free(p);

  return EXIT_SUCCESS;
}
