#include <assert.h>
#include <stdlib.h>

#include "vector.h"
#include "matriu.h"

int main(void)
{
  Vector v;
  float r;

  v = CrearVector(10);
  AssigVector(&v, 5, 100.0);
  r = ConsVector(v, 5);
  DestruirVector(&v);

  Matriu m;

  m = CrearMatriu(3, 4);
  AssigMatriu(&m, 2, 2, 300.0);
  r = ConsMatriu(m, 2, 2);
  DestruirMatriu(&m);

  return EXIT_SUCCESS;
}
